/*******************************************************************************
 *                                                                             *
 *                          NeoMessenger ver:2.0.1                       *
 *                              : NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

$(function() {
/* -------------------------------------------------------------------------- */

    //     1.10 - 1.10.2
    if (jQuery.fn.on === undefined) {
        jQuery.fn.on = function(events, selector, handler) {
            jQuery(this.context).delegate(selector, events, handler);
            return this;
        }
    }

    //     1.10 - 1.10.2
    if (jQuery.fn.off === undefined) {
        jQuery.fn.off = function(events) {
            jQuery(this.context).unbind(events);
            return this;
        }
    }

    //    
    jQuery.extend(jQuery.expr[':'], {
        Contains: function (el, index, meta) {
            var reg = new RegExp('^' + meta[3].toUpperCase(), 'i');
            return reg.test($(el).text().toUpperCase());
        }
    });

/* -------------------------------------------------------------------------- */
    NIM = (function(self, $) {

        self.my_mess       = $('.my_messages a'),
        self.title         = $('title').text(),
        self.url           = '/plugins/p_neomessenger/nim.php',
        self.sound         = '/plugins/p_neomessenger/sounds/notify',
        self.f_s_p         = false;
        self.im_hidden     = true,
        self.isListen      = true,
        self.cur_cnt       = null,
        self.last_msg      = null,
        self.new_msgs      = 0,
        self.bbcodetoolbar = null,
        self.titleTimer    = null,

/* -------------------------------------------------------------------------- */

        self.init = function() {
            $('body').append(
                '<audio id="im_sound">' +
                '  <source src="' + self.sound + '.ogg" type="audio/ogg">' +
                '  <source src="' + self.sound + '.mp3" type="audio/mpeg">' +
                '</audio>'
            );

            $('body').on('click', 'a[href$=\'/messages.html\']', function() {
                $.newWindow();
                self.start();
                return false;
            });

            $('body').on('click', 'a[href$=\'/sendmessage.html\']', function() {
                var id = this.toString().match(/users\/(\d+)\//)[1];
                $.newWindow();
                self.start(id);
                return false;
            });


/* -------------------------------------------------------------------------- */

            $('body').on('windowopen', '#imWindow', function() {
                $(this).on('click', '.user_contact', self.selectContact);
                $(this).on('click', '#mess_sender', function() { self.sendMessage(); });
                $(this).on('keydown', '.composer textarea', function(e) {if(e.keyCode===10||e.keyCode==13){if(e.ctrlKey){$(this).val($(this).val()+"\r");}else{self.sendMessage();return false;}}});
                $(this).on('click', '.composer textarea, .usr_msg_smilebox a', function() { $('#smilespanel-im-message').slideUp('slow'); });
                $(this).on('mouseenter', '.message', function() { $(this).find('.delete').show(); $(this).find('.date').hide(); });
                $(this).on('mouseleave', '.message', function() { $(this).find('.delete').hide(); $(this).find('.date').show(); });
                $(this).on('mouseenter', '.user_contact', function() { if ($(this).attr('rel') != '-1') { $(this).find('.counter').hide(); $(this).find('.delete').show(); } });
                $(this).on('mouseleave', '.user_contact', function() { if ($(this).attr('rel') != '-1') { $(this).find('.counter').show(); $(this).find('.delete').hide(); } });
                $(this).on('mouseenter', '.message.new', self.setMsgReaded);
                $(this).on('click', '.message .delete', self.messDelete);
                $(this).on('click', '.user_contact .delete', function(e) { self.contactDelete($(this).parent()); e.stopPropagation(); });
                $(this).on('keyup', '#search_contact', self.contactFilter);
                $(this).on('click', '#search_clear', function() { $('#im_window .user_contact').slideDown(); $('#search_contact').val(''); $(this).hide(); });
                $(this).on('click', '.show-older', self.showOlder);
                $(window).bind('resize.imwindow', self.resize);
                self.im_hidden = false;
                self.resize();
            });

            $('body').on('windowclose', '#imWindow', function() {
                $(this).off();
                $(window).unbind('resize.imwindow');
                self.im_hidden     = true;
                self.cur_cnt       = null;
                document.title     = self.title;
                clearInterval(self.titleTimer);
            });

            self.listen();
        },

/* -------------------------------------------------------------------------- */

        self.start = function(id) {
            $.post(self.url, {opt: 'getontacts', contact_id: id || ''}, function(data) {
                if (data.contacts.length) {
                    self.bbcodetoolbar = data.bbcodetoolbar;
                    self.smiles        = $('<div>');

                    $.each(data.smiles, function() {
                        $('<a>', {href: 'javascript:addSmile(\'' + this.replace('.gif', '') + '\', \'im-message\')'})
                                .append($('<img>', {src: '/images/smilies/' + this}))
                                .appendTo(self.smiles);
                    });

                    $('#imWindow .window-content').html(
                        '<div id="im_window">' +
                        '    <div class="left-panel">' +
                        '        <div class="search_panel">' +
                        '            <form id="im_filter_form">' +
                        '                <div class="inp_bl">' +
                        '                   <input type="text" id="search_contact" value="" placeholder="   ">' +
                        '                   <div id="search_clear" title=" "></div>' +
                        '                </div>' +
                        '            </form>' +
                        '        </div>' +
                        '        <div id="userlist">' +
                        '        </div>' +
                        '    </div>' +
                        '    <div class="right-panel loading-panel"></div>' +
                        '</div>'
                    );

                    var sound_played = false;
                    var cnts = [];

                    $.each(data.contacts, function() {
                        self.addContact(this);

                        if (this.id != '-1') {
                            cnts.push(this);
                        }

                        if (this.new_messages > 0) {
                            self.setMsgCounter(this.id, this.new_messages);

                            if (!sound_played && self.f_s_p) {
                                self.beep();
                                sound_played = true;
                            } else {
                                self.f_s_p = true;
                            };
                        }
                    });

                    if (data.contacts.length > 1) {
                        self.setMsgCounter(data.contacts[1].id, 0);
                        self.selectContact.call($('#im_window #contact-' + data.contacts[1].id));
                    } else {
                        self.setMsgCounter(data.contacts[0].id, 0);
                        self.selectContact.call($('#im_window #contact-' + data.contacts[0].id));
                    }
                }
            }, "json");
        },

        self.addContact = function(contact) {
            var html = '';

            html += '<div id="contact-' + contact.id + '" class="userlist_item user_contact" rel="' + contact.id + '"><div class="status_info" title=""></div><div class="userpic">';

            if (contact.id != '-1')
            {
                html += '<a href="' + contact.profileUrl + '" target="_blank" title="   "><img src="' + contact.avatar + '" width="31" height="31" class="userpic_image" /></a>';
            } else {
                html += '<img src="' + contact.avatar + '" width="31" height="31" class="userpic_image" />';
            }

            html += '</div><div class="username" title="' + contact.nickname + '">' + self.crop(contact.nickname, 20) + '</div><span class="delete" title=" "></span></div>';

            $('#im_window #userlist').append(html);

            self.setStatus(contact);

            return true;
        },

        self.setStatus = function(contact) {
            var cnt = $('#im_window #contact-' + contact.id);

            if (contact.online == 1) {
                cnt.addClass('_online');
                $('.status_info', cnt).attr('title', '');
            } else {
                cnt.removeClass('_online');
                $('.status_info', cnt).attr('title', '');
            }
        },

        self.setMsgCounter = function(id, value) {
            if (self.new_msgs < 0) {
                self.new_msgs = 0;
            }

            var contact = $('#im_window #contact-' + id);
    
            $('.counter', contact).remove();
    
            if (value > 0) {
                $(contact).append('<span class="counter" title=" : ' + value + '">+ ' + value + '</span>');
            }
        },

        self.selectContact = function() {
            var contact_id = $(this).attr('rel');

            if (contact_id == self.cur_cnt) { return; };

            self.new_msgs = 0;

            $(this).parent().find('div').removeClass('selected');
            $(this).addClass('selected');

            $('#im_window .right-panel').html('').removeClass('loading-panel').addClass('loading-panel');

            $.post(self.url, {opt: 'getMessages', contact_id: contact_id}, function(data) {
                $('#im_window .right-panel').removeClass('loading-panel').html(
                    '<div id="im_contact">' +
                    '    <div id="im_chat" class="chat">' +
                    '        <div class="older-loading"></div>' +
                    '        <div class="show-older">&uarr;    &uarr;</div>' +
                    '    </div>' +
                    '    <div class="composer">' +
                    '        <form name="msgform" id="send_msgform">' +
                    '            <input type="hidden" name="opt" value="sendMessage" />' +
                    '            <input type="hidden" name="contact_id" value="' + contact_id + '" />' +
                    '            <div class="editor">' +
                    '                <div class="usr_msg_bbcodebox">' +
                                         self.bbcodetoolbar +
                    '                </div>' +
                    '                <div class="usr_msg_smilebox" id="smilespanel-im-message">' +
                                        $(self.smiles).html() +
                    '                </div>' +
                    '                <textarea class="textarea_mess" name="message" id="im-message"></textarea>' +
                    '            </div>' +
                    '            <div class="buttons">' +
                    '                <input id="mess_sender" type="button" class="button" name="send" value=" (Enter)">' +
                    '            </div>' +
                    '        </form>' +
                    '    </div>' +
                    '</div>'
                );

                if (contact_id == '-1') {
                    $('#im_window .right-panel .composer').hide();
                    $('#im_contact .chat').css('bottom', '0');
                }

                if (data.messages.length) {
                    var msgs_count = 0;

                    $.each(data.messages, function() {
                        self.addMessage(this);
                        ++msgs_count;
                    });

                    if (data.has_older) {
                        $('#im_window .show-older').attr('rel', data.older_id).show();
                    }

                    self.last_msg = data.messages[data.messages.length - 1].id;
                    self.setMsgCounter(contact_id, self.new_msgs);

                    self.scrollChat();
                }

                self.cur_cnt = contact_id;

                $('#im_window .textarea_mess').focus();
            }, "json");
        },

        self.addMessage = function(message, old) {
            var html = 
                '<div id="message-' + message.id + '" class="message" data-mess_id="' + message.id + '" data-author="' + message.sender_id + '">' +
                '    <div class="title">' +
                '        <span class="author">' +
                             message.author + ':' +
                '        </span>' +
                '        <span class="date">' +
                             message.senddate +
                '        </span>' +
                '        <span class="delete" title=" "></span>' +
                '    </div>' +
                '    <div class="content">' +
                         message.message +
                '    </div>' +
                '</div>';

            if (old) {
                $('#im_contact #im_chat .show-older').after(html);
            } else {
                $('#im_contact .chat').append(html);
            }

            if (self.userId == message.sender_id) {
                $('#im_contact #message-' + message.id).addClass('message-my').find('.author').html('');
            } else {
                if (message.is_new == 1) {
                    $('#im_contact #message-' + message.id).addClass('new');
                    ++self.new_msgs;
                }
            }

            return true;
        },

        self.scrollChat = function () {
            var chat = document.getElementById("im_chat");
            chat.scrollTop = chat.scrollHeight;
        },

        self.sendMessage = function() {
            var form    = $('#im_contact .composer form');
            var content = $('textarea', form).val().trim();

            if (!content) {
                return;
            }

            self.isListen = false;
            $('.usr_msg_smilebox').hide();

            var form_data = self.formToJSON(form);
            form_data.mess_last_id = self.last_msg;

            $('.buttons', form).addClass('sending').find('.button').hide();
            $('textarea', form).attr('disabled', 'disabled');

            $.post(self.url, form_data, function(data) {
                $('.buttons', form).removeClass('sending').find('.button').show();
                $('textarea', form).removeAttr('disabled');
                $('textarea', form).val('');

                if (data.messages.length > 0) {
                    $.each(data.messages, function() {
                        self.addMessage(this);
                    });

                    self.last_msg = data.messages[data.messages.length - 1].id;

                    if (data.messages.length > 1) {
                        self.setMsgCounter(form_data.contact_id, self.new_msgs);
                        self.beep();
                    }

                    self.scrollChat();
                    $('#im_window .textarea_mess').focus();
                    self.isListen = true;
                }
            }, "json");
        },

        self.messDelete = function() {
            var msg = $(this).closest('.message');

            $.post(self.url, {opt: 'delMessage', id: msg.data('mess_id')}, function(result) {
                if (result.error == false) {
                    msg.css('background', '#FFAEAE').fadeOut(function(){$(this).remove();});
                }
            });
        },

        self.contactDelete = function(cnt) {
            if (cnt.hasClass('selected')) {
                alert(' ,    ,      .   ,    .');
            } else {
                if (confirm('     ?')) {
                    $.post(self.url, {opt: 'delContact', id: cnt.attr('rel')}, function(result) {
                        if (result.error == false) {
                            cnt.fadeOut(function(){$(this).remove();});
                        }
                    });
                }
            }  
        },

        self.contactFilter = function() {
            var val = ($(this).val()).trim();

            $('#im_window .user_contact').show();

            if (val.length > 0) {
                $('#im_window .user_contact:not(:Contains(' + val + ')):not(.selected)').slideUp().end();
                $('#im_window #search_clear').show();
            } else {
                $('#im_window .user_contact').slideDown();
                $('#im_window #search_clear').hide();
            }
        },

        self.listen = function() {
            if (self.im_hidden) {
                $.post(self.url, {opt: 'getNewMessages'}, function(data) {
                    var my_mess_count = self.my_mess.text();

                    var count = 0;

                    if (data.newmsgs > 0) {
                        if ((/\((\d+)\)\s?(.*)/).test(my_mess_count)) {
                            count = parseInt(my_mess_count.match(/\((\d+)\)\s?(.*)/)[1]);
                        } else {
                            self.my_mess.addClass('has_new');
                        }

                        if (data.newmsgs > count) {
                            self.my_mess.text(' (' + data.newmsgs +')');
                            self.beep();
                        }
                    }

                    setTimeout(function() { self.listen(); }, self.upTime * 1000);
                }, "json");
            } else {
                if (!self.isListen) {
                    setTimeout(function() { self.listen(); }, self.upTime * 1000);
                    return;
                }

                $.post(self.url, {opt: 'listen', contact_id: self.cur_cnt, mess_last_id: self.last_msg}, function(data) {
                    if (data) {
                        if (data.contacts.length) {
                            $.each(data.contacts, function() {
                                if (!$('#im_window #contact-' + this.id).length) {
                                    self.addContact(this);
                                }

                                self.setStatus(this);

                                if (this.new_messages > 0) {
                                    var contact = $('#im_window #contact-' + this.id);
                                    var old_mes = ($('.counter', contact).text()).substr(2);

                                    self.setMsgCounter(this.id, this.new_messages);

                                    if (old_mes < this.new_messages) {
                                        self.beep();
                                    }
                                }
                            });
                        }

                        if (data.messages.length) {
                            $.each(data.messages, function() {
                                self.addMessage(this);
                            });

                            self.last_msg = data.messages[data.messages.length - 1].id;
                            self.scrollChat();
                        }

                        self.setMsgCounter(self.cur_cnt, self.new_msgs);
                    }

                    setTimeout(function() { self.listen(); }, self.upTime * 1000);
                }, "json");
            }
        },

        self.setMsgReaded = function() {
            $(this).removeClass('new');

            if ($(this).data('author') < '0') {
                self.setMsgCounter('-1', --self.new_msgs);
            } else {
                self.setMsgCounter($(this).data('author'), --self.new_msgs);
            }

            if (self.new_msgs > 0) {
                self.my_mess.attr('title', ' : ' + self.new_msgs).text(' (' + self.new_msgs +')');
            } else {
                self.my_mess.removeClass('has_new').attr('title', '').text('');
            }

            $.post(self.url, {opt: 'setMsgReaded', msg_id: $(this).data('mess_id')});

            clearInterval(self.titleTimer);
            document.title = self.title;
        },

        self.showOlder = function() {
            var im_window  = $('#im_window');
            var im_chat    = $('#im_chat', im_window);
            var _this      = this;

            var message_id = $(this).attr('rel');

            $(this).hide();
            $('.older-loading', im_chat).show();

            $.post(self.url, {opt: 'showOld', contact_id: self.cur_cnt, mess_first_id: message_id}, function(data) {
                $('.older-loading', im_chat).hide();

                if (data.messages)
                {
                    var msgs_count = 0;

                    $.each(data.messages, function() {
                        self.addMessage(this, true);
                        ++msgs_count;
                    });

                    var msg_top = $('#message-' + message_id, im_chat).position().top;
                    im_chat.scrollTop(im_chat.scrollTop() + msg_top);
                }

                if (data.has_older)
                {
                    console.log($(_this));
                    $(_this).attr('rel', data.older_id).show();
                }

            }, "json");

            return true;
        },

        self.resize = function() {
            var heightDiff = $(window).height() - $('#imWindow').height();

            if (heightDiff < 20 || heightDiff > 20) {
                $('#imWindow').css("height", (($(window).height() - 20) + "px"));
            }

            x = ($(window).width() - $('#imWindow').width()) / 2;
            y = ($(window).height() - $('#imWindow').height()) / 2;

            if (x < 10) x = 10;
            if (y < 10) y = 10;

            $.moveWindow('imWindow', x, y);
        },

/* -------------------------------------------------------------------------- */

        self.crop = function(str, len) {
            if (str.length > len) {
                str = str.substr(0, len - 3) + '...';
            }

            return str;
        },

        self.beep = function() {
            $('#im_sound')[0].play();
            clearInterval(self.titleTimer);
            self.flashTitleStart('******     ******');
        },

        self.flashTitleStart = function(title) {
            if (title !== document.title) {
                document.title = title;
            } else {
                document.title = self.title;
            }

            self.titleTimer = setTimeout(function() {
                self.flashTitleStart(title);
            }, 1000);
        },

        self.formToJSON = function(form) {
            var o = {};
            var a = form.serializeArray();

            $.each(a, function() {
                if (o[this.name] !== undefined) {
                    if (!o[this.name].push) {
                        o[this.name] = [o[this.name]];
                    }

                    o[this.name].push(this.value || '');
                } else {
                    o[this.name] = this.value || '';
                }
            });

            return o;
        },

        self.init();
    }(NIM || {}, jQuery));
});