/*******************************************************************************
 *                                                                             *
 *                          NeoMessenger ver: 2.0.1                      *
 *                              : NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

(function($) {

    //  z-index 
    var nimWindowBaseZIndex = 500;

    $.extend({

        newWindow: function(options) {

            //    
            var defaults = $.extend({
                WinId:           'imWindow',
                WinTitle:        '<img src="/plugins/p_neomessenger/img/mail_icon.png" />  ',
                WinContent:      '<div class="mainloading"></div>',
                WinPositionTop:  'center',
                WinPositionLeft: 'center',
                WinWidth:        800,
                WinHeight:       500,
                WinModal:        true,
                WinCloseBgClick: true
            }, options);

            //  
            var options = $.extend(defaults, options);

            var idAttr = (options.WinId) ? 'id="' + options.WinId + '"' : '';
            var ZIndex = ($('body').data('nimWindowMaxZIndex')) ? $('body').data('nimWindowMaxZIndex') : nimWindowBaseZIndex;

            var WinModalBg     = $('<div class="modal-background">').css('z-index', ZIndex++);
            var WinContainer   = $('<div ' + idAttr + ' class="window-container"></div>').css('z-index', ZIndex++);

            $('body').data('nimWindowMaxZIndex', ZIndex);

            var Window = WinContainer.append(
                '<div class="window-titleBar">' +
                    '<div class="window-titleBar-content">' +
                        options.WinTitle +
                    '</div>' +
                    '<div class="window-closeButton"></div>' +
                '</div>' +
                '<div class="window-content">' +
                    options.WinContent +
                '</div>'
            );

            var Title    = Window.find('.window-titleBar');
            var BTNClose = Title.find('.window-closeButton');

            if (options.WinPositionTop == 'center') {
                options.WinPositionTop = ($(window).height() / 2) - options.WinHeight / 2;
            }

            if (options.WinPositionLeft == 'center') {
                options.WinPositionLeft = ($(window).width() / 2) - options.WinWidth / 2;
            }

            BTNClose.bind('click.nimwindow', function(e) {
                Window.fadeOut(function() {
                    Window.remove();
                });

                if (options.WinModal) {
                    WinModalBg.remove();
                }

                Window.trigger('windowclose');
            });

            if (options.WinCloseBgClick) {
                WinModalBg.bind('click.nimwindow', function(e) {
                    BTNClose.click();
                });
            }

            Window.css('top', options.WinPositionTop);
            Window.css('left', options.WinPositionLeft);
            Window.css('width', options.WinWidth);
            Window.css('height', options.WinHeight);
            Window.css('display', 'none');

            $('body').append(Window);

            if (options.WinModal) {
                $('body').append(WinModalBg);
            }

            Window.css('position', 'absolute');
            Window.fadeIn();
            Window.trigger('windowopen');
        },

        moveWindow: function(id, x, y) {
            $obj = $("#" + id);
            x = parseInt(x);
            y = parseInt(y);
            $obj.data("lastX", x).data("lastY", y);
            x = x + "px";
            y = y + "px";
            $obj.css("left", x).css("top", y);
        }
    });
})(jQuery);