<?php

/*******************************************************************************
 *                                                                             *
 *                          NeoMessenger ver:2.0.1                       *
 *                              : NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

    define('PATH', $_SERVER['DOCUMENT_ROOT']);

    Error_Reporting(0);

    if (@$_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest')
    {
        die();
    }

    session_start();

    define("VALID_CMS", 1);

    include(PATH . '/core/cms.php');
    $inCore = cmsCore::getInstance();

    cmsCore::loadClass('page');
    cmsCore::loadClass('user');
    cmsCore::loadClass('actions');

    $inDB = cmsDatabase::getInstance();
    $inConf = cmsConfig::getInstance();
    $inUser = cmsUser::getInstance();
    $inPage = cmsPage::getInstance();

    if ( ! $inUser->update())
    {
        cmsCore::halt();
    }

    cmsCore::loadLanguage('lang');

    if ( ! $inUser->id)
    {
        cmsCore::halt();
    }

    $opt = iconv('UTF-8//IGNORE', 'WINDOWS-1251//IGNORE', $inCore->request('opt', 'str', ''));

    cmsCore::loadModel('users');
    $model_user = new cms_model_users;

    $inCore->includeFile('plugins/p_neomessenger/nim.class.php');

/* -------------------------------------------------------------------------- */

    //    
    if ($opt == 'getNewMessages')
    {
        nim::jsonOutput(array('newmsgs' => (int) cmsUser::isNewMessages($inUser->id)));
    }

/* -------------------------------------------------------------------------- */

    //   
    if ($opt == 'getontacts')
    {
        $contact_id = $inCore->request('contact_id', 'int', 0);

        if ($contact_id)
        {
            $usr = $inUser->loadUser($contact_id);

            //      
            if ( ! $usr)
            {
                cmsCore::halt();
            }

            //      
            if ( ! nim::isContactExists($inUser->id, $contact_id))
            {
                nim::addContact($inUser->id, $contact_id);
            }
            else
            {
                nim::updateContactsDateLastMsg($inUser->id, $contact_id);
            }
        }

        $smiles        = nim::getSmiles();
        $contacts      = nim::getContacts($inUser->id);
        $bbcodetoolbar = cmsPage::getBBCodeToolbar('im-message');
        
        $bbcodetoolbar = str_replace('smilespanel', 'smilespanel-im-message', $bbcodetoolbar);

        nim::jsonOutput(array("contacts" => $contacts, "bbcodetoolbar" => $bbcodetoolbar, "smiles" => $smiles));
    }

/* -------------------------------------------------------------------------- */

    //    
    if ($opt == 'getMessages')
    {
        $contact_id = $inCore->request('contact_id', 'int', 0);

        //     
        if ( ! $contact_id)
        {
            cmsCore::halt();
        }

        $messages = nim::getMessages($inUser->id, $contact_id);

        if ($messages)
        {
            $first_message_id = $messages[0]['id'];
            $has_older = (bool) $inDB->rows_count('cms_user_msg', "from_id IN ({$inUser->id}, {$contact_id}) AND to_id IN ({$inUser->id}, {$contact_id}) AND id < {$first_message_id} AND from_del = 0 AND to_del = 0", 5);
        }
        else
        {
            $first_message_id = false;
            $has_older        = false;
        }

        nim::jsonOutput(array('messages' => $messages, 'has_older' => $has_older, 'older_id' => $first_message_id));
    }

/* -------------------------------------------------------------------------- */

    //      
    if ($opt == 'listen')
    {
        $contact_id   = $inCore->request('contact_id', 'int', 0);
        $mess_last_id = $inCore->request('mess_last_id', 'int', 0);

        if ( ! $contact_id)
        {
            cmsCore::halt();
        }

        nim::onlineUpdate($inUser->id);

        $contacts = nim::getContacts($inUser->id);
        $messages = nim::getMessages($inUser->id, $contact_id, $mess_last_id);

        nim::jsonOutput(array("contacts" => $contacts, "messages" => $messages));
    }

/* -------------------------------------------------------------------------- */

    //  
    if ($opt == 'delMessage')
    {
        $id = cmsCore::request('id', 'int', 0);

        $msg = $inDB->get_fields('cms_user_msg', "id={$id}", '*');

        if ( ! $msg)
        {
            cmsCore::halt();
        }

        //    
        if ($msg['to_id'] == $inUser->id)
        {
            if ($msg['from_id'] > 0)
            {
                $inDB->query("UPDATE cms_user_msg SET to_del=1 WHERE id={$id}");
            }
            else
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id={$id} LIMIT 1");
            }
        }

        //    
        if ($msg['from_id'] == $inUser->id)
        {
            if ($msg['is_new'])
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id = {$id} LIMIT 1");
            }
            else
            {
                $inDB->query("UPDATE cms_user_msg SET from_del=1 WHERE id={$id}");
            }
        }

        //  ,     
        $inDB->query("DELETE FROM cms_user_msg WHERE to_del=1 AND from_del=1");

        nim::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    //  
    if ($opt == 'delContact')
    {
        $id = cmsCore::request('id', 'int', 0);

        //      
        if (nim::isContactExists($inUser->id, $id))
        {
            $inDB->query("DELETE FROM cms_user_contacts WHERE user_id={$inUser->id} AND contact_id={$id}");
        }

        nim::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    //  
    if ($opt == 'sendMessage')
    {
        $contact_id   = $inCore->request('contact_id', 'int', 0);
        $mess_last_id = $inCore->request('mess_last_id', 'int', 0);
        $message      = $inCore->request('message', 'html', '');

        $message = cmsCore::parseSmiles($message, true);
        $message = iconv('UTF-8//IGNORE', 'WINDOWS-1251//IGNORE', $message);

        if ( ! nim::isContactExists($contact_id, $inUser->id))
        {
            nim::addContact($contact_id, $inUser->id);
        }

        nim::updateContactsDateLastMsg($inUser->id, $contact_id, true);

        //  
        $message_id = cmsUser::sendMessage($inUser->id, $contact_id, $message);

        //    email  
        $model_user->sendNotificationByEmail($contact_id, $inUser->id, $message_id);

        nim::jsonOutput(array('messages' => nim::getMessages($inUser->id, $contact_id, $mess_last_id)));
    }

/* -------------------------------------------------------------------------- */

    //    
    if ($opt == 'setMsgReaded')
    {
        $inDB->query("UPDATE cms_user_msg m SET is_new = 0 WHERE m.id = {$inCore->request('msg_id', 'int', 0)} LIMIT 1");
    }

/* -------------------------------------------------------------------------- */

    //   
    if ($opt == 'showOld')
    {
        $contact_id    = $inCore->request('contact_id', 'int', 0);
        $mess_first_id = $inCore->request('mess_first_id', 'int', 0);

        $messages = nim::getMessages($inUser->id, $contact_id, 0, $mess_first_id);

        if ($messages)
        {
            $first_message_id = $messages[0]['id'];
            $has_older = (bool) $inDB->rows_count('cms_user_msg', "from_id IN ({$inUser->id}, {$contact_id}) AND to_id IN ({$inUser->id}, {$contact_id}) AND id < {$first_message_id} AND from_del = 0 AND to_del = 0", 5);
        }
        else
        {
            $first_message_id = false;
            $has_older        = false;
        }

        nim::jsonOutput(array("messages" => array_reverse($messages), "has_older" => $has_older, "older_id" => $first_message_id)); 
    }

/* -------------------------------------------------------------------------- */

    cmsCore::halt();