<?php

/*******************************************************************************
 *                                                                             *
 *                          NeoMessenger ver:2.0.1                       *
 *                              : NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

class p_neomessenger extends cmsPlugin {

    public function __construct()
    {
        parent::__construct();

        //   

        $this->info['plugin']      = 'p_neomessenger';
        $this->info['title']       = 'NeoMessenger (icms_1.9)';
        $this->info['description'] = '       instantCMS 1.9';
        $this->info['author']      = '<a target="_blank" href="http://vk.com/filinov_victor">NEOm@ster</a>';
        $this->info['version']     = '2.0.1';

        //  -

        $this->config['   ()'] = 20;

        // ,    

        $this->events[] = 'PRINT_PAGE_HEAD';
    }

/* -------------------------------------------------------------------------- */

    /**
     *   
     * @return bool
     */
    public function install()
    {
        $inDB = cmsDatabase::getInstance();

        //         
        $inDB->query('DROP TABLE IF EXISTS cms_user_contacts');

        //      
        $inDB->query('
            CREATE TABLE cms_user_contacts (
              id int(11) NOT NULL AUTO_INCREMENT,
              user_id int(11) DEFAULT NULL,
              contact_id int(11) DEFAULT NULL,
              date_last_msg timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
              PRIMARY KEY (id),
              KEY user_id (user_id),
              KEY contact_id (contact_id)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        ');

        //         
        $res = $inDB->query('
            SELECT from_id, to_id, from_del, to_del
            FROM cms_user_msg
            ORDER BY senddate ASC
        ');

        if ($inDB->num_rows($res))
        {
            $values = array();

            //   
            while ($item = $inDB->fetch_assoc($res))
            {
                if ( ! (int) $item['from_del'])
                {
                    $value = array((int) $item['from_id'], (int) $item['to_id']);

                    if ( ! in_array($value, $values) AND $value[0] > 0)
                    {
                        $values[] = $value;
                        $inDB->query("INSERT INTO cms_user_contacts (user_id, contact_id) VALUES ({$value[0]}, {$value[1]})");
                    }
                }

                if ( ! (int) $item['to_del'])
                {
                    $value = array((int) $item['to_id'], (int) $item['from_id']);

                    if ( ! in_array($value, $values) AND $value[0] > 0)
                    {
                        $values[] = $value;
                        $inDB->query("INSERT INTO cms_user_contacts (user_id, contact_id) VALUES ({$value[0]}, {$value[1]})");
                    }
                }
            }
        }

        return parent::install();
    }

/* -------------------------------------------------------------------------- */

    //  
    public function upgrade()
    {
        return parent::upgrade();
    }

/* -------------------------------------------------------------------------- */
    
    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event = '', $item = array())
    {
        parent::execute();

        switch ($event)
        {
            case 'PRINT_PAGE_HEAD'  : $item = $this->AddPluginToPage($item); break;
        }

        return $item;
    }

/* -------------------------------------------------------------------------- */

    /**
     *     
     */
    private function AddPluginToPage($head)
    {
        $inUser = cmsUser::getInstance();

        if ( ! $inUser->id)
        {
            return $head;
        }

        $inPage = cmsPage::getInstance();

        //       
        $inPage->addHead("
            <script>
                var NIM = {
                    userId: {$inUser->id},
                    upTime: {$this->config['   ()']}
                };
            </script>
        ");
                    
        $no_cache = '1000';

        //    
        $inPage->addHeadJS('core/js/smiles.js');
        $inPage->addHeadCSS('plugins/p_neomessenger/css/style.css?no_cache='  . $no_cache);
        $inPage->addHeadJS('plugins/p_neomessenger/js/window.js?no_cache='    . $no_cache);
        $inPage->addHeadJS('plugins/p_neomessenger/js/messenger.js?no_cache=' . $no_cache);

        //  head
        return $inPage->page_head;
    }

/* -------------------------------------------------------------------------- */

}